=== debian/changelog ===
btop (1.4.0-0.1~mx23+1) mx; urgency=medium

  * New upstream release v1.4.0
  * Add lowdown to BDs to generate manpage.

 -- Steven Pusser <stevep@mxlinux.org>  Sun, 29 Sep 2024 17:51:19 -0700
