=== debian/control ===
Source: btop
Section: utils
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Marius Gripsgard <mariogrip@debian.org>
Build-Depends: debhelper-compat (= 13),
               lowdown
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://github.com/aristocratos/btop
Vcs-Browser: https://salsa.debian.org/mariogrip/btop
Vcs-Git: https://salsa.debian.org/mariogrip/btop.git

Package: btop
Architecture: linux-any
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Modern, colorful CLI resource monitor that shows usage and stats
 btop is a modern and colorful command line resource monitor that shows
 usage and stats for processor, memory, disks, network and processes.
 btop features:
  - Easy to use, with a game inspired menu system.
  - Full mouse support, all buttons with a highlighted key is clickable
  and mouse scroll works in process list and menu boxes.
  - Fast and responsive UI with UP, DOWN keys process selection.
  - Function for showing detailed stats for selected process.
  - Ability to filter processes.
  - Easy switching between sorting options.
  - Tree view of processes.
  - Send any signal to selected process.
  - UI menu for changing all config file options.
  - Auto scaling graph for network usage.
  - Shows IO activity and speeds for disks
  - Battery meter
  - Selectable symbols for the graphs
  - Custom presets
  - And more...
  btop is written in C++ and is a continuation of bashtop and bpytop.
