=== debian/changelog ===
btop (1.4.4-1) unstable; urgency=medium

  [ Otto Kekäläinen ]
  * New upstream release 1.4.4 (Closes: #1084966)

  [ Joel Orón Valiente ]
  * debian/control: Bump standards version to 4.7.2.
  * Add all new packages to licensed files to fix lintian warning.
  * Add hardening flags to fix lintian warning: hardening-no-fortify-functions.
  * Add Otto, Andrew and Joel to the copyright.

 -- Otto Kekäläinen <otto@debian.org>  Mon, 03 Nov 2025 13:23:57 -0800
