=== debian/control ===
--- 
+++ 
@@ -1,21 +1,19 @@
 Source: btop
 Section: utils
 Priority: optional
-Maintainer: Steven Pusser <stevep@mxlinux.org>
-XSBC-Original-Maintainer: Marius Gripsgard <mariogrip@debian.org>
-Build-Depends: debhelper-compat (= 13),
-               lowdown
-Standards-Version: 4.6.2
+Maintainer: Otto Kekäläinen <otto@debian.org>
+Build-Depends: debhelper-compat (= 13)
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://github.com/aristocratos/btop
-Vcs-Browser: https://salsa.debian.org/mariogrip/btop
-Vcs-Git: https://salsa.debian.org/mariogrip/btop.git
+Vcs-Browser: https://salsa.debian.org/otto/btop
+Vcs-Git: https://salsa.debian.org/otto/btop.git
 
 Package: btop
 Architecture: linux-any
 Multi-Arch: foreign
 Depends: ${misc:Depends}, ${shlibs:Depends}
-Description: Modern, colorful CLI resource monitor that shows usage and stats
+Description: Modern and colorful command line resource monitor that shows usage and stats
  btop is a modern and colorful command line resource monitor that shows
  usage and stats for processor, memory, disks, network and processes.
  btop features:
@@ -35,4 +33,4 @@
   - Selectable symbols for the graphs
   - Custom presets
   - And more...
-  btop is written in C++ and is a continuation of bashtop and bpytop.
+  btop is written in C++ and is continuation of bashtop and bpytop.
