=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/btop-$1\.tar\.gz/ \
  https://github.com/aristocratos/btop/tags .*/v?(\d\S+)\.tar\.gz
