## btop 1.4.5

=== debian/changelog ===
btop (1.4.5-1) unstable; urgency=medium

  * New upstream release (Closes: #1120916)
  * Update and format debian/copyright
  * Drop obsolete `Rules-Requires-Root: no`
  * Add patch to have README placed in correct path by upstream build
  * Use upstream man page and drop the custom Debian one as obsolete
  * Make build properly verbose so Debian log analyzers can see what happened

 -- Otto Kekäläinen <otto@debian.org>  Sat, 22 Nov 2025 11:50:08 -0800
