=== debian/control ===
--- 
+++ 
@@ -2,9 +2,10 @@
 Section: utils
 Priority: optional
 Maintainer: Otto Kekäläinen <otto@debian.org>
-Build-Depends: debhelper-compat (= 13)
+Build-Depends:
+ debhelper-compat (= 13),
+ lowdown,
 Standards-Version: 4.7.2
-Rules-Requires-Root: no
 Homepage: https://github.com/aristocratos/btop
 Vcs-Browser: https://salsa.debian.org/otto/btop
 Vcs-Git: https://salsa.debian.org/otto/btop.git
@@ -12,7 +13,9 @@
 Package: btop
 Architecture: linux-any
 Multi-Arch: foreign
-Depends: ${misc:Depends}, ${shlibs:Depends}
+Depends:
+ ${misc:Depends},
+ ${shlibs:Depends},
 Description: Modern and colorful command line resource monitor that shows usage and stats
  btop is a modern and colorful command line resource monitor that shows
  usage and stats for processor, memory, disks, network and processes.
