=== debian/rules ===
#!/usr/bin/make -f

# See FEATURE AREAS/ENVIRONMENT in dpkg-buildflags(1)
# Apply all hardening options
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
# Package maintainers to append CFLAGS
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic

include /usr/share/dpkg/buildflags.mk
CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)

# According to Debian Policy version 4.2.0 builds should be as verbose as
# possible unless 'terse' is specifically passed.
ifeq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
    export DH_VERBOSE = 1
		# See btop Makefile
    export VERBOSE = true
    export QUIET = false
endif

# Override default /usr/local with proper system path
export PREFIX := /usr

%:
	dh $@ --

override_dh_auto_install:
	dh_auto_install -- DESTDIR=$(CURDIR)/debian/tmp
