=== debian/changelog ===
btop (1.4.6-2) unstable; urgency=medium

  * Fix printf format string error in info target visible on Launchpad builds,
    which prevented 1.4.6-1 from building in Ubuntu resolute-proposed and thus
    latest btop had not migrated to Ubuntu resolute (26.04)

 -- Otto Kekäläinen <otto@debian.org>  Thu, 12 Feb 2026 12:12:12 +0000

btop (1.4.6-1) unstable; urgency=medium

  * New upstream release
  * Switch debian/watch to use GitHub template and uscan version 5
  * Add Lintian override for missing OpenPGP signature check
  * Update Debian copyright for 2026
  * Drop redundant `Priority: optional`
  * Bump Debian Policy version

 -- Otto Kekäläinen <otto@debian.org>  Wed, 07 Jan 2026 05:38:41 +0000
