=== debian/control ===
--- 
+++ 
@@ -1,11 +1,10 @@
 Source: btop
 Section: utils
-Priority: optional
 Maintainer: Otto Kekäläinen <otto@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
  lowdown,
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Homepage: https://github.com/aristocratos/btop
 Vcs-Browser: https://salsa.debian.org/otto/btop
 Vcs-Git: https://salsa.debian.org/otto/btop.git
